/*
 * $Source: /cvs/sources/com/odisei/sdk/samples/addtoaddress/AddToAddressObserverPhone.java,v $
 * $Revision: 1.3 $
 * $Date: 1999/09/30 14:49:32 $
 * $Author: kris $
 *
 * Copyright (c) 1999 by 8x8, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of 8x8. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with 8x8.
 *
 */

import javax.telephony.*;
import javax.telephony.events.*;
import javax.telephony.phone.*;
import javax.telephony.phone.events.*;

/**
* This PhoneTerminalObserver implementation observes user actions on a phone.
*/
public class AddToAddressObserverPhone implements PhoneTerminalObserver {

	/*Implementation of phoneTerminalObserver*/
	public void terminalChangedEvent(TermEv[] eventList) {

		for (int i = 0; i < eventList.length; i++) {
			TermEv phoneEvent = (TermEv)eventList[i];
			Terminal terminal = phoneEvent.getTerminal();
			String msg = "Phone : " + terminal.getName() + " state is ";

			switch(eventList[i].getID()) {
				case ButtonPressEv.ID :
					System.out.println(msg + "ButtonPress :" + ((ButtonPressEv)eventList[i]).getInfo());
					break;

				case HookswitchStateEv.ID :
					if (((HookswitchStateEv)eventList[i]).getHookSwitchState() == PhoneHookswitch.OFF_HOOK) {
						System.out.println("-------------------------------------------------");
						System.out.println(msg + "Hookswitch off:");
						System.out.println("The server executed one of the following:");
						System.out.println("- answer() : If the TerminalConnection of the Terminal was in ringing state.");
						System.out.println("- createCall() & offHook() : If the Terminal had no TerminalConnection.");
						System.out.println("---------------------------------------------------");
						}
					else {
						System.out.println("-------------------------------------------------");
						System.out.println(msg + "Hookswitch on");
						System.out.println("The server executed a drop on the current call.");
						System.out.println("If the other party was still off hook, it woud have executed a createCall() & offHook() on it.");
						System.out.println("-------------------------------------------------");  
						}
					break;
					
				case RingerVolumeEv.ID :
					if (((RingerVolumeEv)eventList[i]).getVolume() == PhoneRinger.FULL)
						System.out.println(msg + "RingerVolume Full"); 					
					else if (((RingerVolumeEv)eventList[i]).getVolume() == PhoneRinger.MIDDLE)
						System.out.println(msg + "RingerVolume Middle");
					else if (((RingerVolumeEv)eventList[i]).getVolume() == PhoneRinger.OFF)
						System.out.println(msg + "RingerVolume Off");
					break;
			}
		}
	}
}
/*
 * $Log: AddToAddressObserverPhone.java,v $
 * Revision 1.3  1999/09/30 14:49:32  kris
 * Minor changes for the IntraSwitch iPBX System Evaluation.
 *
 * Revision 1.2  1999/07/08 08:46:19  kris
 * comments reviewed
 *
 * Revision 1.1  1999/07/06 19:16:10  isa
 * initial release
 *
 */
