/*
 * $Source: /cvs/sources/com/odisei/sdk/samples/simplecall/Incall.java,v $
 * $Revision: 1.3 $
 * $Date: 1999/09/30 16:02:02 $
 * $Author: kris $
 *
 * Copyright (c) 1999 by 8x8, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of 8x8. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with 8x8.
 *
 */

import javax.telephony.*;
import javax.telephony.events.*;

/**
 Create a Provider and monitor a particular Terminal for an incoming call
 */

public class Incall {

	public static final void main(String[] args) {
		/*
		Create a Provider by first obtaining the 8x8 implementation of
		JTAPI and then the specific Provider implementation indicated by the Provider String.
		The CTI Server host address is specified in that string.
		*/
		String ctiServerHost = null;
		if (args == null || args.length < 1)
			throw new RuntimeException("Need cti server host name as parameter");

		ctiServerHost = args[0];

		Provider myProvider = null;
		try {
			JtapiPeer peer = JtapiPeerFactory.getJtapiPeer("com.odisei.server.x.engine.EngineJtapiPeer");
			myProvider = peer.getProvider("cce;com.odisei.telephony.host=" + ctiServerHost +  ";login=admin;passwd=admin");
		}
		catch (Exception excp) {
			throw new RuntimeException("Can't get provider : " + excp.toString());
		}

		/*
        Get the terminal we wish to monitor and add a CallObserver to that
        Terminal. This will place a CallObserver on all Call which come to
        that terminal. Terminals involved in this example are named 101 and 102
     	*/
		try {
			Terminal terminal = myProvider.getTerminal("102");
			terminal.addCallObserver(new MyInCallObserver());
		}
		catch (Exception excp) {
			throw new RuntimeException("Can't get terminal : " + excp.toString());
		}
   	}
}
