/*
 * $Source: /cvs/sources/com/odisei/sdk/samples/simplecall/MyInCallObserver.java,v $
 * $Revision: 1.3 $
 * $Date: 1999/09/30 16:02:02 $
 * $Author: kris $
 *
 * Copyright (c) 1999 by 8x8, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of 8x8. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with 8x8.
 *
 */

import javax.telephony.*;
import javax.telephony.events.*;

/**
The MyInCallObserver class implements the CallObserver and receives
all Call-related events
*/
public class MyInCallObserver implements CallObserver {

	public void callChangedEvent(CallEv[] eventList) {
		TerminalConnection termConn;
		String name;
		for (int i = 0;  i < eventList.length; i++) {
			
			if (eventList[i] instanceof TermConnEv) {
				termConn = null;
				name = null; 
				
				try {
					TermConnEv tcev = (TermConnEv)eventList[i];
					termConn = tcev.getTerminalConnection();
					Terminal terminal = termConn.getTerminal();
					name = terminal.getName();
				}	
				catch (Exception exc) {
					//handle events
				}
					
				String msg = "TerminalConnection to terminal : " + name + " is ";
				switch(eventList[i].getID()) {
					
					case TermConnActiveEv.ID :
						System.out.println(msg + "Active");
						break;
						
					case TermConnRingingEv.ID :
						System.out.println(msg + "Ringing");
						/* answer the thelephone call using inner class thread */
						try {
							final TerminalConnection tc = termConn;
							Runnable r = new Runnable() {
									public void run() {
										try {
											System.out.println("answer service is blocked until the hookwitch will be in off state"); 
											tc.answer();
										}
										catch (Exception e) {
											System.out.println(e.toString());
										}	
									}
								};
								
							Thread thread = new Thread(r);
							thread.start();
						}
						catch (Exception e) {
							//handle exceptions
						}	 
						break;
						
					case TermConnDroppedEv.ID :
						System.out.println(msg + "Dropped");		
						break;
				}
			}	  	
		} 
	}  
}
