/*
 * $Source: /cvs/sources/com/odisei/sdk/samples/simplecall/MyOutCallObserver.java,v $
 * $Revision: 1.3 $
 * $Date: 1999/09/30 16:02:02 $
 * $Author: kris $
 *
 * Copyright (c) 1999 by 8x8, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of 8x8. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with 8x8.
 *
 */

import javax.telephony.*;
import javax.telephony.events.*;

/**
The MyOutCallObserver class implementes the CallObserver interface
and receive all events associated with the call.
*/

public class MyOutCallObserver implements CallObserver {
	
	public void callChangedEvent(CallEv[] eventList) {
	
		for (int i = 0; i < eventList.length; i++) {
			if (eventList[i] instanceof ConnEv) {
				String name = null;
				try {
					Connection connection = ((ConnEv)eventList[i]).getConnection();
					Address address = connection.getAddress();
					name = address.getName();
				}
				catch (Exception exc) {
					// handle exceptions
				} 	
					
				String msg = "Connection to address :" + name + " is ";
				
				switch(eventList[i].getID()) {
					case ConnAlertingEv.ID :
						System.out.println(msg + "Alerting");
						break;
						
					case ConnInProgressEv.ID :
						System.out.println(msg + " In Progress");
						break;
						
					case ConnConnectedEv.ID :
						System.out.println(msg + " Connected");
						break;
					
					case ConnDisconnectedEv.ID :
						System.out.println(msg + "Disconnected");
						break;							   	  
				} 	
			} 
		}   
	}  
}
