/*
 * $Source: /cvs/sources/com/odisei/sdk/samples/simplecall/Outcall.java,v $
 * $Revision: 1.3 $
 * $Date: 1999/09/30 16:02:02 $
 * $Author: kris $
 *
 * Copyright (c) 1999 by 8x8, Inc.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of 8x8. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with 8x8.
 *
 */

import javax.telephony.*;
import javax.telephony.events.*;


/**
Places a telephone call from 101 to 102 
*/
public class Outcall {
	public static final void main(String[] args) {
	
		/* 
		Create a Provider by first obtaining the 8x8 implementation of
		JTAPI and then the specific Provider implementation indicated by the Provider String.
		The CTI Server host address is specified in that string.
		*/
		String urlServer = null;
		if (args == null || args.length < 1) 
			throw new RuntimeException("Need url server for connecting provider");
			
		urlServer = args[0];
			  
		Provider myProvider = null;
		try {
			JtapiPeer peer = JtapiPeerFactory.getJtapiPeer("com.odisei.server.x.engine.EngineJtapiPeer");
			myProvider = peer.getProvider("cce;com.odisei.telephony.host=" + urlServer +  ";login=admin;passwd=admin"); 	  
		}
		catch (Exception e) {
			throw new RuntimeException("Can't get Provider "+ e.toString()); 
		}
			
		/*
		 We need to get appropriate objects associated with the originating side of the telephone call.
		 We ask the Address of Terminals on it and arbitrarily choose the one named 101.
		*/
		Address oriAddress = null;
		Terminal oriTerminal = null;
		try {
			oriAddress = myProvider.getAddress("101");
			/* Just get some Terminal on this Address */
			oriTerminal = oriAddress.getTerminals()[0];
		}
		catch (Exception e) {
			// handle exceptions
		}

		/*
		Create the telephone Call object and add a CallObserver
		*/
		Call myCall = null;
		try {
			myCall = myProvider.createCall();
			myCall.addObserver(new MyOutCallObserver());
		}
		catch (Exception exc) {
			throw new RuntimeException("Can't create a call" + exc.toString());
		}

		try {
			System.out.println("connect service was invoked, please hang-up the phone 101");
			System.out.println("we implements prompting  in connect service");
			Connection c[] = myCall.connect(oriTerminal, oriAddress, "102");
		}
		catch (Exception excp) {
			throw new RuntimeException("Can't connect address 101 to address 102");
		}
	}
}
